﻿// IDNameDlg.cpp: 实现文件
//

#include "pch.h"
#include "aike.h"
#include "aikeDlg.h"
#include "afxdialogex.h"
#include "IDNameDlg.h"


// IDNameDlg 对话框

IMPLEMENT_DYNAMIC(IDNameDlg, MyDialog)

IDNameDlg::IDNameDlg(CWnd* pParent /*=nullptr*/)
	: MyDialog(IDD_IDNAMEDLG, pParent)
{
	m_Parent = pParent;
}

IDNameDlg::~IDNameDlg()
{
}

void IDNameDlg::DoDataExchange(CDataExchange* pDX)
{
	MyDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, m_List);
}


BEGIN_MESSAGE_MAP(IDNameDlg, MyDialog)
	ON_BN_CLICKED(IDOK, &IDNameDlg::OnBnClickedOk)
	ON_NOTIFY(NM_CLICK, IDC_LIST1, &IDNameDlg::OnNMClickList1)
END_MESSAGE_MAP()


// IDNameDlg 消息处理程序


void IDNameDlg::OnBnClickedOk()
{
	// TODO: 在此添加控件通知处理程序代码

}


BOOL IDNameDlg::OnInitDialog()
{
	MyDialog::OnInitDialog();

	// TODO:  在此添加额外的初始化
	FixedSize();
	m_List.SetExtendedStyle(m_List.GetExtendedStyle() | LVS_EX_DOUBLEBUFFER | LVS_EX_HEADERDRAGDROP | LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT);
	int i = 0;
	m_List.InsertColumn(i++, _T("ID"), LVCFMT_LEFT, 60);
	m_List.InsertColumn(i++, _T("名称"), LVCFMT_LEFT, 120);
	LoadData();
	CRect rt = { 0, 0, 75, 30 };
	rt.MoveToXY(10, 300);
	AddButton(1, rt);
	SetLClick(1, [this](int i) {AddClick(i); });
	SetButText(1, _T("添加"));

	rt.OffsetRect(80,0);
	AddButton(2, rt);
	SetLClick(2, [this](int i) {UpdateClick(i); }); 
	SetButText(2, _T("修改"));

	rt.OffsetRect(80, 0);
	AddButton(3, rt);
	SetLClick(3, [this](int i) {DeleteClick(i); });
	SetButText(3, _T("删除"));

	rt.OffsetRect(80, 0);
	AddButton(4, rt);
	SetLClick(4, [this](int i) {PreserveClick(i); });
	EnableButton(4, FALSE);
	SetButText(4, _T("保存"));

	rt.OffsetRect(80, 0);
	AddButton(5, rt);
	SetLClick(5, [this](int i) {CancelClick(i); });
	EnableButton(5, FALSE);
	SetButText(5, _T("取消"));

	rt.OffsetRect(80, 0);
	AddButton(6, rt);
	SetLClick(6, [this](int i) {CloseClick(i); });
	SetButText(6, _T("关闭"));

	return TRUE;  // return TRUE unless you set the focus to a control
	// 异常: OCX 属性页应返回 FALSE
}

void IDNameDlg::LoadData()
{
	m_List.DeleteAllItems();
	CaikeDlg* dlg = (CaikeDlg*)theApp.MainDlg;
	CString sqlStr,tmp;
	sqlStr.Format(_T("select * from %s"), form);
	_RecordsetPtr m_pRecor;
	_variant_t var;
	dlg->AdoSql.QuerySql(sqlStr, m_pRecor);
	int i = 0;
	while (!m_pRecor->GetadoEOF())
	{
		var = m_pRecor->GetCollect("ID");
		if (var.vt != VT_NULL)
		{
			tmp = (LPCTSTR)_bstr_t(var);
		}
		if (tmp == _T(""))
		{
			m_pRecor->MoveNext();
			continue;
		}
		m_List.InsertItem(i, tmp);
		var = m_pRecor->GetCollect("name");
		if (var.vt != VT_NULL)
		{
			tmp = (LPCTSTR)_bstr_t(var);
			m_List.SetItemText(i, 1, tmp);
		}
		m_pRecor->MoveNext();
		i++;
	}
}

VOID IDNameDlg::AddDate()
{
	CaikeDlg* dlg = (CaikeDlg*)theApp.MainDlg;
	CString name;
	GetDlgItemText(IDC_EDIT2, name);
	if (name.GetLength() > 10)
	{
		MessageBox(_T("名称不能超过十位汉字"), _T("温馨提示"));
		return;
	}
	if (name == _T(""))
	{
		MessageBox(_T("名称不能为空"), _T("温馨提示"));
		return;
	}
	CString sqlStr;
	sqlStr.Format(_T("INSERT INTO %s (name) VALUES ('%s')"), form, name);
	if (!dlg->AdoSql.ImplementSQL(sqlStr))
	{
		MessageBox(_T("名称添加失败，请检查项目名称是否重复"), _T("温馨提示"));
	}

}

VOID IDNameDlg::UpdateDate()
{
	CaikeDlg* dlg = (CaikeDlg*)theApp.MainDlg;
	CString name, id;
	GetDlgItemText(IDC_EDIT1, id);
	GetDlgItemText(IDC_EDIT2, name);
	if (id == _T(""))
	{
		return;
	}
	if (name.GetLength() > 10)
	{
		MessageBox(_T("名称不能超过十位汉字"), _T("温馨提示"));
		return;
	}
	if (name == _T(""))
	{
		MessageBox(_T("名称不能为空"), _T("温馨提示"));
		return;
	}
	CString sqlStr;
	sqlStr.Format(_T("UPDATE %s set name = '%s' where ID = %s"), form, name, id);
	if (!dlg->AdoSql.ImplementSQL(sqlStr))
	{
		MessageBox(_T("名称添加失败，请检查项目名称是否重复"), _T("温馨提示"));
	}
}


VOID IDNameDlg::AddClick(int ID)
{
	flag = 1; 
	GetDlgItem(IDC_EDIT2)->EnableWindow(TRUE);
	EnableButton(1, FALSE);
	EnableButton(2, FALSE);
	EnableButton(3, FALSE);
	EnableButton(4, TRUE);
	EnableButton(5, TRUE);
	PaintDlg();
}

VOID IDNameDlg::UpdateClick(int ID)
{
	CString tmp;
	GetDlgItemText(IDC_EDIT1, tmp);
	if (tmp == _T(""))
	{
		return;
	}
	flag = 2;
	GetDlgItem(IDC_EDIT2)->EnableWindow(TRUE);
	EnableButton(1, FALSE);
	EnableButton(2, FALSE);
	EnableButton(3, FALSE);
	EnableButton(4, TRUE);
	EnableButton(5, TRUE);
	LoadData();
	PaintDlg();
}

VOID IDNameDlg::DeleteClick(int ID)
{
	CaikeDlg* dlg = (CaikeDlg*)theApp.MainDlg;
	CString sqlStr, tmp;
	GetDlgItemText(IDC_EDIT1, tmp);
	if (tmp != _T(""))
	{
		_RecordsetPtr m_pRecor;
		_variant_t var;
		if (form == _T("roomregion") || form == _T("roomtype"))
		{
			sqlStr.Format(_T("select * from room where %s = '%s'"), form, tmp);
			dlg->AdoSql.QuerySql(sqlStr, m_pRecor);
			int i = 0;
			if (!m_pRecor->GetadoEOF())
			{
				MessageBox(_T("该名称已经使用,不允许删除"), _T("温馨提示"));
				return;
			}
		}
		sqlStr.Format(_T("delete from %s where ID = %s"), form, tmp);
		if (!dlg->AdoSql.ImplementSQL(sqlStr))
		{
			MessageBox(_T("SQL执行失败"), _T("温馨提示"));
		}
		else
		{
			flag = 0;
			GetDlgItem(IDC_EDIT2)->EnableWindow(FALSE);
			SetDlgItemText(IDC_EDIT1, _T(""));
			SetDlgItemText(IDC_EDIT2, _T(""));
			LoadData();
		}
	}
}

VOID IDNameDlg::PreserveClick(int ID)
{
	if (flag == 1)
	{
		AddDate();
	}
	else if (flag == 2)
	{
		UpdateDate();
	}
	flag = 0;
	GetDlgItem(IDC_EDIT2)->EnableWindow(FALSE);
	SetDlgItemText(IDC_EDIT1, _T(""));
	SetDlgItemText(IDC_EDIT2, _T(""));
	EnableButton(1, TRUE);
	EnableButton(2, TRUE);
	EnableButton(3, TRUE);
	EnableButton(4, FALSE);
	EnableButton(5, FALSE);
	LoadData();
	PaintDlg();
}

VOID IDNameDlg::CancelClick(int ID)
{
	flag = 0;
	GetDlgItem(IDC_EDIT2)->EnableWindow(FALSE);
	EnableButton(1, TRUE);
	EnableButton(2, TRUE);
	EnableButton(3, TRUE);
	EnableButton(4, FALSE);
	EnableButton(5, FALSE);
	PaintDlg();
}

VOID IDNameDlg::CloseClick(int ID)
{
	MyDialog::OnCancel();
}


void IDNameDlg::OnNMClickList1(NMHDR* pNMHDR, LRESULT* pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	// TODO: 在此添加控件通知处理程序代码
	if (flag == 0)
	{
		if (pNMItemActivate->iItem == -1)
		{
			SetDlgItemText(IDC_EDIT1, _T(""));
			SetDlgItemText(IDC_EDIT2, _T(""));
		}
		else
		{
			SetDlgItemText(IDC_EDIT1, m_List.GetItemText(pNMItemActivate->iItem, 0));
			SetDlgItemText(IDC_EDIT2, m_List.GetItemText(pNMItemActivate->iItem, 1));
		}
	}
	*pResult = 0;
}

